class IntelHex

	attr_accessor :intelhex
	attr_accessor :object

	def initialize
		@intelhex = Array.new
		@object = Hash.new
	end

	def encode_hex(object = @object)
		@intelhex = Array.new
		object.keys.sort.each {|adr|
			pt = -16; while(dat = object[adr].slice(pt += 16, 16) and dat.size > 0)
				dat.unshift(dat.size, adr + pt >> 8, adr + pt & 0xFF, 0)
				sum = 0; dat.each {|c| sum += c }; sum %= 0x100
				dat.push(0x100 - sum)
				@intelhex << ':' + dat.pack('C*').unpack('H*')[0].upcase
			end
		}
		@intelhex << ':00000001FF'
	end

	def decode_hex(intelhex = @intelhex)
		@object = Hash.new
		adr = nil; intelhex.each {|l|
			break unless(dat = parse_hex(l.strip))
			next if(dat.size == 0 or dat[1] != 0)
			if(adr and adr + @object[adr].size == dat[0])
				@object[adr] += dat[2]
			else
				@object[adr = dat[0]] = dat[2]
			end
		}
	end

	def parse_hex(l)
		if(l =~ /^\s*$/ or l =~ /^#/)
			return [] 
		elsif(l =~ /^:([0-9A-Z]{2})([0-9A-Z]{4})([0-9A-Z]{2})([0-9A-Z]*)([0-9A-Z]{2})$/)
			rlen = $1; radr = $2; rtype = $3; rdat = $4; rsum = $5
			# check len
			raise "length error[#{l}]" unless(rlen.to_i(16) == rdat.length / 2)
			# check sum
			dat = [rlen + radr + rtype + rdat + rsum].pack('H*').unpack('C*')
			sum = 0; dat.each {|c| sum += c }; sum %= 0x100
			raise "checksum error[#{l}]" unless(sum == 0)
			# end check
			return nil if(rlen == '00' and rtype == '01')
			# store dat
			return radr.to_i(16), rtype.to_i(16), [rdat].pack('H*').unpack('C*')
		else
			raise "format error[#{l}]"
		end
	end
end
