class Integer

	def seeable_chr
		self < 0x20 ? '.' : (self < 0x7f ? self.chr : '.')
	end
end

class Ndump

	def initialize(adr = 0, options = '')
		@adr = adr
		@chr = ''
		@opt = options.split(',')
		@skip = Array.new
		(0...16).each {|n|
			@skip[n] = ''
			@skip[n] = ' ' if(n % 2 == 1 and @opt.include?('skip2'))
		}
		@skip[15] = ''
		@sep = "\n#Adr.   "
		(0...16).each {|n|
			@sep += sprintf('+%X%s ', n, @skip[n])
		}
		@sep += "'Character\n"
	end

	def <<(c)
		rep = ''
		rep += @sep if(@adr % 256 == 0)
		rep += sprintf('#%04X = ', @adr) if(@adr % 16 == 0)
		rep += sprintf('%s%s ', c ? sprintf('%02X', c) : '  ', @skip[@adr % 16])
		@chr += c ? c.seeable_chr : ' '
		@chr += @skip[@adr % 16]
		if(@adr % 16 == 15)
			rep += "'#{@chr}\n"
			@chr = ''
		end
		@adr += 1
		rep
	end

	def tail
		rep = ''
		rep += (self << nil) until(@adr % 16 == 0)
		rep
	end
end

